#ifndef SWIG__COMMON__NDS_EPOCH_HH
#define SWIG__COMMON__NDS_EPOCH_HH

#include <string>
#include <utility>
#include <vector>

namespace NDS
{
	class epoch {
	public:
		std::string name;
		buffer::gps_second_type gps_start;
		buffer::gps_second_type gps_stop;

		epoch():name(""), gps_start(0), gps_stop(0) {};
		epoch(const std::string& name, buffer::gps_second_type start, buffer::gps_second_type stop): name(name), gps_start(start), gps_stop(stop) {};
		epoch(const epoch &other): name(other.name), gps_start(other.gps_start), gps_stop(other.gps_stop) {};
	};

	typedef std::vector<epoch> epochs_type;
}

#endif