import binascii
import collections
import struct

Channel = collections.namedtuple(
    'Channel',
    'name rate type tp_num group unit gain slope offset')


channels = {}

def _pack_daq_float32(val):
    return binascii.hexlify(struct.pack("!f", val))

def _pack_daq_int32(val):
    return binascii.hexlify(struct.pack("!I", val))

def _pack_daq_int16(val):
    return binascii.hexlify(struct.pack("!H", val))

def sc3_12_1(channel, out):
    print "Status channels 3 for %s\n" % channel.name
    out.write(channel.name + "\n")
    out.write(str(channel.rate) + "\n")
    out.write(str(channel.type) + "\n")
    out.write(str(channel.tp_num) + "\n")
    out.write(str(channel.group) + "\n")
    out.write(channel.unit + "\n")
    out.write(str(channel.gain) + "\n")
    out.write(str(channel.slope) + "\n")
    out.write(str(channel.offset) + "\n")
    out.flush()

def sc2_12_1(channel, out):
    print "Status channels 2 for %s\n" % channel.name
    out.write(channel.name)
    out.write(" " * (60 - len(channel.name)))
    out.write(_pack_daq_int32(channel.rate))
    out.write(_pack_daq_int32(channel.tp_num))
    out.write(_pack_daq_int16(channel.group))
    out.write(_pack_daq_int16(channel.type))
    out.write(_pack_daq_float32(channel.gain))
    out.write(_pack_daq_float32(channel.slope))
    out.write(_pack_daq_float32(channel.offset))
    out.write(channel.unit)
    out.write(" " * (40 - len(channel.unit)))
    out.flush()

def validate_action(action, args):
    if action == "register_chan" and len(args) == 9:
        return
    if action == "gen_sc3_12_1" and len(args) == 1:
        return
    if action == "gen_sc2_12_1" and len(args) >= 1:
        return

def execute_action(action, args, inp, out):
    global channels

    if action == "register_chan":
        chan = Channel(*args)
        channels[chan.name] = chan
    elif action == "gen_sc3_12_1":
        sc3_12_1(channels[args[0]], out)
    elif action == "gen_sc2_12_1":
        for name in args:
            sc2_12_1(channels[name], out)
    out.flush()