
import os

import nds

if os.environ.has_key('NDS_TEST_OLD'):
    import nds2 as nds
else:
    import nds

hostname = 'localhost'
if os.environ.has_key('NDS_TEST_HOST'):
    hostname = os.environ['NDS_TEST_HOST']

port = 31200
if os.environ.has_key('NDS_TEST_PORT'):
    port = int(os.environ['NDS_TEST_PORT'])

conn = nds.connection(hostname, port, nds.connection.PROTOCOL_TWO)

start = 1116733655
stop = 1116733675

channels = [
    "H1:SUS-ETMX_M0_MASTER_OUT_F1_DQ",
    "H1:SUS-ETMX_M0_MASTER_OUT_F2_DQ",
    "H1:SUS-ETMX_M0_MASTER_OUT_F3_DQ",
    "H1:SUS-ETMX_M0_MASTER_OUT_LF_DQ",
    "H1:SUS-ETMX_M0_MASTER_OUT_RT_DQ",
    "H1:SUS-ETMX_M0_MASTER_OUT_SD_DQ",
    "H1:SUS-ETMX_L1_MASTER_OUT_UL_DQ",
    "H1:SUS-ETMX_L1_MASTER_OUT_UR_DQ",
    "H1:SUS-ETMX_L1_MASTER_OUT_LL_DQ",
    "H1:SUS-ETMX_L1_MASTER_OUT_LR_DQ",
    "H1:SUS-ETMX_L2_MASTER_OUT_UL_DQ",
    "H1:SUS-ETMX_L2_MASTER_OUT_UR_DQ",
    "H1:SUS-ETMX_L2_MASTER_OUT_LL_DQ",
    "H1:SUS-ETMX_L2_MASTER_OUT_LR_DQ",
    "H1:SUS-ETMX_L3_MASTER_OUT_UL_DQ",
    "H1:SUS-ETMX_L3_MASTER_OUT_UR_DQ",
]

conn.set_epoch(start, stop)

avail = conn.get_availability(channels)
assert( len(channels) == len(avail) )

for i in xrange(len(channels)):
    entry = avail[i]
    assert(channels[i] == entry.name)
    assert(len(entry.data) == 2)
    assert(entry.data[0].frame_type == "H-H1_C")
    assert(entry.data[1].frame_type == "H-H1_R")
    assert(entry.data[0].gps_start == entry.data[1].gps_start)
    assert(entry.data[0].gps_stop == entry.data[1].gps_stop)
    assert(entry.data[0].gps_start == start)
    assert(entry.data[0].gps_stop == stop)

simple_list = avail.simple_list()
assert(len(simple_list) == len(avail))

entry = simple_list[0]
assert(len(entry) == 1)
assert(entry[0].gps_start == start)
assert(entry[0].gps_stop == stop)

conn.fetch(start, stop, channels)